## mingw-w64-python-polars-1.37.0-1.src.tar.zst

=== py-polars/Makefile ===
.DEFAULT_GOAL := help

PYTHONPATH=
SHELL=bash
ifeq ($(VENV),)
VENV := ../.venv
endif

ifeq ($(OS),Windows_NT)
	VENV_BIN=$(VENV)/Scripts
else
	VENV_BIN=$(VENV)/bin
endif

.PHONY: .venv
.venv:  ## Set up virtual environment and install requirements
	@$(MAKE) -s -C .. $@

.PHONY: requirements
requirements: .venv  ## Install/refresh Python project requirements
	@$(MAKE) -s -C .. $@

.PHONY: requirements-all
requirements-all: .venv  ## Install/refresh all Python requirements (including those needed for CI tests)
	@$(MAKE) -s -C .. $@

.PHONY: build
build: .venv  ## Compile and install Python Polars for development
	@$(MAKE) -s -C .. $@

.PHONY: build-release
build-release: .venv  ## Compile and install Python Polars binary with optimizations, with minimal debug symbols
	@$(MAKE) -s -C .. $@

.PHONY: build-nodebug-release
build-nodebug-release: .venv  ## Same as build-release, but without any debug symbols at all (a bit faster to build)
	@$(MAKE) -s -C .. $@

.PHONY: build-debug-release
build-debug-release: .venv  ## Same as build-release, but with full debug symbols turned on (a bit slower to build)
	@$(MAKE) -s -C .. $@

.PHONY: build-dist-release
build-dist-release: .venv  ## Compile and install Python Polars binary with super slow extra optimization turned on, for distribution
	@$(MAKE) -s -C .. $@
	
.PHONY: fix
fix:
	@$(MAKE) -s -C .. $@

.PHONY: lint
lint: .venv  ## Run lint checks (only)
	$(VENV_BIN)/ruff check
	$(VENV_BIN)/typos ..
	-$(VENV_BIN)/mypy

.PHONY: fmt
fmt: .venv  ## Run autoformatting (python and rust)
	$(VENV_BIN)/ruff format
	cargo fmt --all
	-dprint fmt

.PHONY: clippy
clippy:  ## Run clippy
	cargo clippy --locked -- -D warnings -D clippy::dbg_macro

.PHONY: pre-commit
pre-commit: fmt lint clippy  ## Run all code formatting, lint, and clippy quality checks

.PHONY: test
test: .venv build  ## Run fast unittests
	POLARS_TIMEOUT_MS=60000 $(VENV_BIN)/pytest -n auto $(PYTEST_ARGS)

.PHONY: test-streaming
test-streaming: .venv build  ## Run fast unittests with the streaming engine
	POLARS_TIMEOUT_MS=60000 POLARS_AUTO_NEW_STREAMING=1 $(VENV_BIN)/pytest -n auto -m "not may_fail_auto_streaming and not docs and not benchmark and not ci_only" $(PYTEST_ARGS)

.PHONY: test-all
test-all: .venv build  ## Run all tests
	POLARS_TIMEOUT_MS=60000 $(VENV_BIN)/pytest -n auto -m "slow or not slow"
	$(VENV_BIN)/python tests/docs/run_doctest.py

.PHONY: doctest
doctest: .venv build  ## Run doctests
	$(VENV_BIN)/python tests/docs/run_doctest.py
	$(VENV_BIN)/pytest tests/docs/test_user_guide.py -m docs

.PHONY: docs
docs: .venv  ## Build Python docs (incremental)
	@$(MAKE) -s -C docs html

.PHONY: docs-clean
docs-clean: .venv  ## Build Python docs (full rebuild)
	@$(MAKE) -s -C docs clean
	@$(MAKE) docs

.PHONY: coverage
coverage: .venv build  ## Run tests and report coverage
	POLARS_TIMEOUT_MS=60000 $(VENV_BIN)/pytest --cov -n auto -m "not release and not benchmark"

.PHONY: clean
clean:  ## Clean up caches and build artifacts
	@$(MAKE) -s -C docs clean
	@rm -rf .hypothesis/
	@rm -rf .mypy_cache/
	@rm -rf .pytest_cache/
	@$(VENV_BIN)/ruff clean
	@rm -rf tests/data/pdsh/sf*
	@rm -f .coverage
	@rm -f coverage.xml
	@rm -f polars/polars.abi3.so
	@find . -type f -name '*.py[co]' -delete -or -type d -name __pycache__ -exec rm -r {} +

.PHONY: help
help:  ## Display this help screen
	@echo -e "\033[1mAvailable commands:\033[0m"
	@grep -E '^[a-z.A-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | awk 'BEGIN {FS = ":.*?## "}; {printf "  \033[36m%-22s\033[0m %s\n", $$1, $$2}' | sort

=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.su>

_realname=polars
pkgbase=mingw-w64-python-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-python-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-python-${_realname}-runtime-64")
pkgver=1.37.0
pkgrel=1
pkgdesc="Extremely fast Query Engine for DataFrames, written in Rust (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.pola.rs/'
msys2_repository_url='https://github.com/pola-rs/polars'
license=('spdx:MIT')
msys2_references=(
  'archlinux: python-polars'
  'anitya: 179760'
  'purl: pkg:pypi/polars'
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-rust"
  "${MINGW_PACKAGE_PREFIX}-maturin"
  "${MINGW_PACKAGE_PREFIX}-python-installer"
  "${MINGW_PACKAGE_PREFIX}-python-build"
  "${MINGW_PACKAGE_PREFIX}-python-setuptools"
  "${MINGW_PACKAGE_PREFIX}-sed"
  'git'
)
options=('!strip' '!lto')
source=("${msys2_repository_url}/archive/py-${pkgver}/${_realname}-py-${pkgver}.tar.gz")
noextract=("${_realname}-py-${pkgver}.tar.gz")
sha256sums=('b4afb25d863efab9de824f613c75c50b777a324c55992440bcbb0e04a771db05')

prepare() {
  tar -xf "${_realname}-py-${pkgver}.tar.gz" || true

  cd "${_realname}-py-${pkgver}/py-polars"

  cp ../LICENSE .
  cp ../rust-toolchain.toml .

  sed -i 's/polars-runtime-32/polars-runtime-64/g' pyproject.toml

  cargo fetch \
    --locked \
    --config='net.git-fetch-with-cli=true' \
    --target "${RUST_CHOST}"
}

build() {
  cd "${_realname}-py-${pkgver}/py-polars"

  export _PYTHON_HOST_PLATFORM=$(python -c "import sysconfig, sys; sys.stdout.write(sysconfig.get_platform())")
  export WINAPI_NO_BUNDLED_LIBRARIES=1
  python -m build --wheel --no-isolation --skip-dependency-check
  maturin build -o dist --release --locked --strip \
   --no-default-features --features full \
   --compatibility linux \
   --manifest-path runtime/polars-runtime-64/Cargo.toml 
}

package_python-polars() {
  cd "${_realname}-py-${pkgver}/py-polars"

  depends=(
    "${MINGW_PACKAGE_PREFIX}-python"
    "${MINGW_PACKAGE_PREFIX}-python-numpy"
    "${MINGW_PACKAGE_PREFIX}-python-polars-runtime-64"
  )
  optdepends=(
    "${MINGW_PACKAGE_PREFIX}-python-pandas: for interoperability with pandas frames"
    "${MINGW_PACKAGE_PREFIX}-python-pyarrow: for interoperability with arrow types"
    "${MINGW_PACKAGE_PREFIX}-python-pytz: to enable conversion to python datetimes with timezones"
    "${MINGW_PACKAGE_PREFIX}-python-fastexcel: for reading excel workbooks"
    #"${MINGW_PACKAGE_PREFIX}-python-fsspec: to transparently open files locally or remotely"
  )

  python -m installer -d "$pkgdir" ./dist/polars-*.whl

  MSYS2_ARG_CONV_EXCL="--prefix=" \
    python -m installer --prefix=${MINGW_PREFIX} \
    --destdir="${pkgdir}" ./dist/polars-*.whl

  install -Dm0644 LICENSE -t "${pkgdir}${MINGW_PREFIX}/share/licenses/python-${_realname}/"

  # Remove duplicate files (for more info see https://github.com/msys2/MINGW-packages/pull/26356)
  cd "${pkgdir}"
  for _df in $(ls | grep -v ${MINGW_PREFIX/\//}); do rm -rf $_df; done
}

package_python-polars-runtime-64() {
  cd "${_realname}-py-${pkgver}/py-polars"

  pkgdesc+=" (native runtime libraries)"
  depends=("${MINGW_PACKAGE_PREFIX}-python")

  MSYS2_ARG_CONV_EXCL="--prefix=" \
    python -m installer --prefix=${MINGW_PREFIX} \
    --destdir="${pkgdir}" ./dist/polars_runtime*.whl

  install -Dm0644 LICENSE -t "${pkgdir}${MINGW_PREFIX}/share/licenses/python-${_realname}-runtime-64/"
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
